/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the JObjectBulkOperationResult type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &JObjectBulkOperationResult{}

// JObjectBulkOperationResult struct for JObjectBulkOperationResult
type JObjectBulkOperationResult struct {
	Success   *bool          `json:"success,omitempty"`
	Data      interface{}    `json:"data,omitempty"`
	Exception *ExceptionInfo `json:"exception,omitempty"`
	RequestId NullableString `json:"requestId,omitempty"`
	Message   NullableString `json:"message,omitempty"`
}

// NewJObjectBulkOperationResult instantiates a new JObjectBulkOperationResult object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewJObjectBulkOperationResult() *JObjectBulkOperationResult {
	this := JObjectBulkOperationResult{}
	return &this
}

// NewJObjectBulkOperationResultWithDefaults instantiates a new JObjectBulkOperationResult object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewJObjectBulkOperationResultWithDefaults() *JObjectBulkOperationResult {
	this := JObjectBulkOperationResult{}
	return &this
}

// GetSuccess returns the Success field value if set, zero value otherwise.
func (o *JObjectBulkOperationResult) GetSuccess() bool {
	if o == nil || IsNil(o.Success) {
		var ret bool
		return ret
	}
	return *o.Success
}

// GetSuccessOk returns a tuple with the Success field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JObjectBulkOperationResult) GetSuccessOk() (*bool, bool) {
	if o == nil || IsNil(o.Success) {
		return nil, false
	}
	return o.Success, true
}

// HasSuccess returns a boolean if a field has been set.
func (o *JObjectBulkOperationResult) HasSuccess() bool {
	if o != nil && !IsNil(o.Success) {
		return true
	}

	return false
}

// SetSuccess gets a reference to the given bool and assigns it to the Success field.
func (o *JObjectBulkOperationResult) SetSuccess(v bool) {
	o.Success = &v
}

// GetData returns the Data field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JObjectBulkOperationResult) GetData() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.Data
}

// GetDataOk returns a tuple with the Data field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JObjectBulkOperationResult) GetDataOk() (*interface{}, bool) {
	if o == nil || IsNil(o.Data) {
		return nil, false
	}
	return &o.Data, true
}

// HasData returns a boolean if a field has been set.
func (o *JObjectBulkOperationResult) HasData() bool {
	if o != nil && !IsNil(o.Data) {
		return true
	}

	return false
}

// SetData gets a reference to the given interface{} and assigns it to the Data field.
func (o *JObjectBulkOperationResult) SetData(v interface{}) {
	o.Data = v
}

// GetException returns the Exception field value if set, zero value otherwise.
func (o *JObjectBulkOperationResult) GetException() ExceptionInfo {
	if o == nil || IsNil(o.Exception) {
		var ret ExceptionInfo
		return ret
	}
	return *o.Exception
}

// GetExceptionOk returns a tuple with the Exception field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JObjectBulkOperationResult) GetExceptionOk() (*ExceptionInfo, bool) {
	if o == nil || IsNil(o.Exception) {
		return nil, false
	}
	return o.Exception, true
}

// HasException returns a boolean if a field has been set.
func (o *JObjectBulkOperationResult) HasException() bool {
	if o != nil && !IsNil(o.Exception) {
		return true
	}

	return false
}

// SetException gets a reference to the given ExceptionInfo and assigns it to the Exception field.
func (o *JObjectBulkOperationResult) SetException(v ExceptionInfo) {
	o.Exception = &v
}

// GetRequestId returns the RequestId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JObjectBulkOperationResult) GetRequestId() string {
	if o == nil || IsNil(o.RequestId.Get()) {
		var ret string
		return ret
	}
	return *o.RequestId.Get()
}

// GetRequestIdOk returns a tuple with the RequestId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JObjectBulkOperationResult) GetRequestIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.RequestId.Get(), o.RequestId.IsSet()
}

// HasRequestId returns a boolean if a field has been set.
func (o *JObjectBulkOperationResult) HasRequestId() bool {
	if o != nil && o.RequestId.IsSet() {
		return true
	}

	return false
}

// SetRequestId gets a reference to the given NullableString and assigns it to the RequestId field.
func (o *JObjectBulkOperationResult) SetRequestId(v string) {
	o.RequestId.Set(&v)
}

// SetRequestIdNil sets the value for RequestId to be an explicit nil
func (o *JObjectBulkOperationResult) SetRequestIdNil() {
	o.RequestId.Set(nil)
}

// UnsetRequestId ensures that no value is present for RequestId, not even an explicit nil
func (o *JObjectBulkOperationResult) UnsetRequestId() {
	o.RequestId.Unset()
}

// GetMessage returns the Message field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *JObjectBulkOperationResult) GetMessage() string {
	if o == nil || IsNil(o.Message.Get()) {
		var ret string
		return ret
	}
	return *o.Message.Get()
}

// GetMessageOk returns a tuple with the Message field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *JObjectBulkOperationResult) GetMessageOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Message.Get(), o.Message.IsSet()
}

// HasMessage returns a boolean if a field has been set.
func (o *JObjectBulkOperationResult) HasMessage() bool {
	if o != nil && o.Message.IsSet() {
		return true
	}

	return false
}

// SetMessage gets a reference to the given NullableString and assigns it to the Message field.
func (o *JObjectBulkOperationResult) SetMessage(v string) {
	o.Message.Set(&v)
}

// SetMessageNil sets the value for Message to be an explicit nil
func (o *JObjectBulkOperationResult) SetMessageNil() {
	o.Message.Set(nil)
}

// UnsetMessage ensures that no value is present for Message, not even an explicit nil
func (o *JObjectBulkOperationResult) UnsetMessage() {
	o.Message.Unset()
}

func (o JObjectBulkOperationResult) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o JObjectBulkOperationResult) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Success) {
		toSerialize["success"] = o.Success
	}
	if o.Data != nil {
		toSerialize["data"] = o.Data
	}
	if !IsNil(o.Exception) {
		toSerialize["exception"] = o.Exception
	}
	if o.RequestId.IsSet() {
		toSerialize["requestId"] = o.RequestId.Get()
	}
	if o.Message.IsSet() {
		toSerialize["message"] = o.Message.Get()
	}
	return toSerialize, nil
}

type NullableJObjectBulkOperationResult struct {
	value *JObjectBulkOperationResult
	isSet bool
}

func (v NullableJObjectBulkOperationResult) Get() *JObjectBulkOperationResult {
	return v.value
}

func (v *NullableJObjectBulkOperationResult) Set(val *JObjectBulkOperationResult) {
	v.value = val
	v.isSet = true
}

func (v NullableJObjectBulkOperationResult) IsSet() bool {
	return v.isSet
}

func (v *NullableJObjectBulkOperationResult) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableJObjectBulkOperationResult(val *JObjectBulkOperationResult) *NullableJObjectBulkOperationResult {
	return &NullableJObjectBulkOperationResult{value: val, isSet: true}
}

func (v NullableJObjectBulkOperationResult) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableJObjectBulkOperationResult) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
